Available in🇮🇳 India
You should perform the following steps to create and charge your customer subsequent payments:
3.1. Create an Order to Charge the Customer
You have to create a new order every time you want to charge your customers. This order is different from the one created during the authorisation transaction.Handy TipsYou can use the notification object in the request if you want to control pre-debit notifications and recurring debits.
POST /orders
Request Parameters
Request Parameters
amount mandatory
: integer Amount in currency subunits. For cards, the minimum value is 100, that is, ₹1.currency mandatory
: string The 3-letter ISO currency code for the payment.receipt optional
: string A user-entered unique identifier for the order. For example, Receipt No. 1. You should map this parameter to the order_id sent by Razorpay.notification
: object Details of the pre-debit notification. This object is optional. You should use it only if you want to control pre-debit notifications and debits. If you do not pass this object, we will automatically try to debit after 36 hours and 5 minutes.Handy TipsThe TAT to create a debit if you send a pre-debit notification is 36 hours and 5 minutes.
token_id mandatory
: string The token_id generated when the customer successfully completes the authorisation payment. Different payment instruments for the same customer have different token_id.payment_after optional
: integer UNIX timestamp post which the debit is supposed to happen. Defaults to 36 hours and 5 minutes after the pre-debit notification is delivered.notes optional
: object Key-value pair you can use to store additional information about the entity. Maximum of 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.payment_capture mandatory
: boolean Determines whether the payment status should be changed to captured automatically or not. Possible values:true: Payments are captured automatically.false: Payments are not captured automatically. You can manually capture payments using the Manually Capture Payments API.
Response Parameters
Response Parameters
id
: string A unique identifier of the order created. For example order_1Aa00000000001.entity
: string The entity that has been created. Here it is order.amount
: integer Amount in currency subunits.amount_paid
: integer The amount that has been paid.amount_due
: integer The amount that is yet to be paid.currency
: string The 3-letter ISO currency code for the payment.receipt
: string A user-entered unique identifier of the order. For example, rcptid #1.notification
: object Details of the pre-debit notification.token_id
: string The token_id generated when the customer successfully completes the authorisation payment. Different payment instruments for the same customer have different token_id.payment_after
: integer UNIX timestamp post which the debit is supposed to happen.id
: string the unique identifier of the notification. For example, notification_00000000000001.status
: string The status of the order.notes
: object Key-value pair you can use to store additional information about the entity. Maximum of 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.created_at
: integer The Unix timestamp at which the order was created.3.2. Create a Recurring Payment
Once you have generated anorder_id, use it with the token_id to create a payment and charge the customer. The following endpoint creates a payment to charge the customer.
POST /payments/create/recurring
- You will get a
razorpay_payment_id,razorpay_order_idandrazorpay_signatureas a response after the payment request is successfully processed. - In the case of some banks, such as HDFC Bank and Axis Bank, the payment entity is in the
createdstate since the charging system of these banks is file-based and can take some time.
Request Parameters
Request Parameters
email mandatory
: string The customer’s email address. For example, gaurav.kumar@example.com.contact mandatory
: integer The customer’s phone number. For example, 9876543210.currency mandatory
: string 3-letter ISO currency code for the payment. Currently, only INR is allowed.amount mandatory
: integer The amount you want to charge your customer. This should be the same as the order amount.order_idmandatory
: string The unique identifier of the order created. For example, order_1Aa00000000002.customer_id mandatory
: string The unique identifier of the customer you want to charge. For example, cust_1Aa00000000002.token mandatory
: string The token_id generated when the customer successfully completes the authorisation payment. Different payment instruments for the same customer have different token_id.recurring mandatory
: boolean Determines whether recurring payment is enabled or not.true: Recurring payment is enabled.false: Recurring payment is not enabled.
descriptionoptional
: string A user-entered description for the payment. For example, Creating recurring payment for Gaurav Kumarnotesoptional
: object Key-value pair you can use to store additional information about the entity. Maximum of 15 key-value pairs, 256 characters each. For example, "note_key": "Beam me up Scotty”.Response Parameters
Response Parameters
razorpay_payment_id
: string The unique identifier of the payment that is created. For example, pay_1Aa00000000001.razorpay_order_id
: string The unique identifier of the order that is created. For example, order_1Aa00000000001.razorpay_signature
: string The signature generated by the Razorpay. For example, 9ef4dffbfd84f1318f6739a3ce19f9d85851857ae648f114332d8401e0949a3dError Response Parameters
Error Response Parameters
Given below is a list of possible errors you may face while creating a Recurring Payment.
3.3. Fetch an Order With ID
Use this endpoint to retrieve details of a particular order as per the id.GET /v1/orders/:id
Path Parameter
Path Parameter
id mandatory
: string Unique identifier of the order to be retrieved.Response Parameters
Response Parameters
id
: string The unique identifier of the order.amount
: integer The amount for which the order was created, in currency subunits. For example, for an amount of ₹295, enter 29500.entity
: string Name of the entity. Here, it is order.amount_paid
: integer The amount paid against the order.amount_due
: integer The amount pending against the order.currency
: string ISO code for the currency in which you want to accept the payment. The default length is 3 characters. Refer to the list of supported currencies.receipt
: string Receipt number that corresponds to this order. Can have a maximum length of 40 characters and has to be unique.notification
: object Details of the pre-debit notification. The notification object is populated in the response only if you have passed this while creating an order.token_id
: string The token_id generated when the customer successfully completes the authorisation payment. Different payment instruments for the same customer have different token_id.payment_after
: integer Unix timestamp post which the debit is supposed to happen.id
: string Unique identifier of the notification.delivered_at
: integer Indicates the unix timestamp when the notification was delivered.status
: string The status of the order. Possible values:created: When you create an order it is in thecreatedstate. It stays in this state till a payment is attempted on it.attempted: An order moves fromcreatedtoattemptedstate when a payment is first attempted on it. It remains in theattemptedstate till one payment associated with that order is captured.paid: After the successful capture of the payment, the order moves to thepaidstate. No further payment requests are permitted once the order moves to thepaidstate. The order stays in thepaidstate even if the payment associated with the order is refunded.
attempts
: integer The number of payment attempts, successful and failed, that have been made against this order.notes
: json object Key-value pair that can be used to store additional information about the entity. Maximum 15 key-value pairs, 256 characters (maximum) each. For example, "note_key": "Beam me up Scotty”.created_at
: integer Indicates the Unix timestamp when this order was created.